package com.zipcodewilmington.froilansfarm.Concrete;

import com.zipcodewilmington.froilansfarm.Abstract.Crop;
import com.zipcodewilmington.froilansfarm.Interfaces.Botanist;
import com.zipcodewilmington.froilansfarm.Interfaces.Produce;

import java.util.ArrayList;

public class Field {

    private ArrayList<CropRow> rows = new ArrayList<CropRow>(5);

    public Field(){
        this.rows.add(new CropRow());
        this.rows.add(new CropRow());
        this.rows.add(new CropRow());
        this.rows.add(new CropRow());
        this.rows.add(new CropRow());
    }

    public String displayAllRows() {
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i < this.rows.size(); i++){
            String cropRowName = this.rows.get(i).getCropName();
            sb.append(String.format("%d. %s\n", i, cropRowName));
        }
        return sb.toString();
    }

    public String displaySingleRow(int index){
        return String.format("%d. %s", index, this.rows.get(index).getCropName());
    }

    public void plantRow(Botanist botanist, int index, Crop crop) {
        this.rows.get(index).setCrop(crop);
    }

    public ArrayList<CropRow> getRows(){
        return this.rows;
    }

    public void setRows(ArrayList<CropRow> cropRows){
        this.rows = cropRows;
    }

    public CropRow getRow(int index){
        return this.rows.get(index);
    }

    public CropRow setRow(int index){
        return this.rows.get(index);
    }

    public void yield() {
        for (CropRow row: this.rows) {
            if(row.getCrop() != null){
                row.yield();
            }
        }
    }

    public void yield(int row){
        this.rows.get(row).yield();
    }

    public int getProduceCount() {
        int counter = 0;
        for (CropRow row: this.rows) {
            if(row.getCrop() != null){
                counter += row.getCrop().getCount();
            }
        }
        return counter;
    }

    public int getProduceCount(int row) {
        return 0;
    }

    public ArrayList<Produce> harvest() {
        ArrayList<Produce> total = new ArrayList<Produce>();

        for (CropRow cr: this.rows) {
            total.addAll(cr.harvest());
        }

        return total;

    }
}
