package com.zipcodewilmington.froilansfarm.Concrete;

import com.zipcodewilmington.froilansfarm.Interfaces.Botanist;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class CropDusterTest {

    Pilot pilot;
    Field field;
    CropDuster cropDuster;
    Botanist botanist;

    @Before
    public void setup(){
        this.cropDuster = new CropDuster();
        this.field = new Field();
        this.botanist = new Farmer("Nick", 13, true);
        this.pilot = new Pilot("Billy", 13, false);

        field.plantRow(this.botanist,0,  new TomatoPlant());
        field.plantRow(this.botanist,1,  new CornStalk());
    }

    @Test
    public void fertilize() {
        //When
        this.field.yield();
        cropDuster.setPilot(this.pilot);
        cropDuster.setFieldToFertilize(this.field);

        Assert.assertFalse(this.field.getRow(0).hasBeenFertilized());
        Assert.assertFalse(this.field.getRow(1).hasBeenFertilized());

        cropDuster.fertilize();

        Assert.assertTrue(this.field.getRow(0).hasBeenFertilized());
        Assert.assertTrue(this.field.getRow(1).hasBeenFertilized());
    }
}