package com.zipcodewilmington.froilansfarm.Concrete;

import com.zipcodewilmington.froilansfarm.Abstract.Crop;
import com.zipcodewilmington.froilansfarm.Abstract.Person;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import static org.junit.Assert.*;

public class FarmHouseTest {


    Farm farm;
    FarmHouse farmHouse;
    ArrayList<Crop> testProduce;
    private final ByteArrayOutputStream outContent = new ByteArrayOutputStream();
    private final ByteArrayOutputStream errContent = new ByteArrayOutputStream();
    private final PrintStream originalOut = System.out;
    private final PrintStream originalErr = System.err;

    @Before
    public void setUpStreams() {
        System.setOut(new PrintStream(outContent));
        System.setErr(new PrintStream(errContent));
    }


    @Before
    public void setup(){
        //When
        farm = new Farm();
        farmHouse = farm.getFarmHouse();
        testProduce = new ArrayList<Crop>();
    }

    @Test
    public void amountOfPeopleInFarmHouse() {
            farmHouse.addPerson("Froilan", farm.getPeopleAtFarm());

            int expected = 1;

            //Actual
            int actual = farmHouse.amountOfPeopleInFarmHouse();

            Assert.assertEquals(expected,actual);

    }

    @Test
    public void removePerson() {
        farmHouse.addPerson("Froilan", farm.getPeopleAtFarm());
        farmHouse.removePerson("Froilan", farm.getNames());

        int expected = 0;

        //Actual
        int actual = farmHouse.amountOfPeopleInFarmHouse();

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void removePersonWhoIsNotHome() {
        farmHouse.addPerson("Froilan", farm.getPeopleAtFarm());
        farmHouse.removePerson("Froilanda", farm.getNames());

        String expected = "Froilanda is not home.\n";



        Assert.assertEquals(expected,outContent.toString());

    }

    @Test
    public void removePersonWhenNoneIsHome() {
        farmHouse.removePerson("Froilanda", farm.getNames());

        String expected = "No one is home.\n";



        Assert.assertEquals(expected,outContent.toString());

    }

    @Test
    public void removePersonWhenPersonIsNotOnFarm() {
        farmHouse.removePerson("Tommy", farm.getNames());

        String expected = "That person is not on this farm.\n";



        Assert.assertEquals(expected,outContent.toString());

    }



    @Test
    public void getPeople() {
        ArrayList<String> expected = new ArrayList<String>();
        expected.add("Froilan the Farmer");
        expected.add("Froilanda the Pilot");


        farmHouse.addPerson("Froilan", farm.getPeopleAtFarm());
        farmHouse.addPerson("Froilanda", farm.getPeopleAtFarm());

        ArrayList<String> actual = farmHouse.getPeople();


        Assert.assertEquals(expected,actual);
    }

    @Test
    public void removeCrop() {
    }

    @Test
    public void Inventory() {


    }


    @After
    public void restoreStreams() {
        System.setOut(originalOut);
        System.setErr(originalErr);
    }
}