package com.zipcodewilmington.froilansfarm.Concrete;
import com.zipcodewilmington.froilansfarm.Interfaces.Botanist;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;


public class FieldTest {

    Field field;
    Botanist botanist;

    @Before
    public void setup(){
        //When
        field = new Field();
        botanist = new Farmer("Nick", 24, true);
    }

    @Test
    public void setFieldRow(){
        //When
        field.plantRow(botanist, 0, new TomatoPlant());
        field.plantRow(botanist, 1, new CornStalk());

        //Expect
        String expected = "CornStalk";

        //Actual
        String actual = field.getRow(1).getCropName();

        Assert.assertEquals(expected,actual);

    }

    @Test
    public void displayAllRowsTest(){
        //When
        field.plantRow(botanist,0, new TomatoPlant());
        field.plantRow(botanist,1, new CornStalk());

        // Expect
        String expect = "0. TomatoPlant\n1. CornStalk\n2. Empty Crop Row\n3. Empty Crop Row\n4. Empty Crop Row\n";

        //Actual
        String actual = field.displayAllRows();

        Assert.assertEquals(expect, actual);
    }

    @Test
    public void displaySingleRowsTest(){
        //When
        field.plantRow(botanist,0, new TomatoPlant());
        field.plantRow(botanist,1, new CornStalk());

        // Expect
        String expect = "0. TomatoPlant";

        //Actual
        String actual = field.displaySingleRow(0);

        Assert.assertEquals(expect, actual);
    }


}