package com.zipcodewilmington.froilansfarm.Concrete;

import com.sun.xml.internal.ws.policy.AssertionSet;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class StablesTest {

    Stable stable;

    @Before
    public void setup(){
        stable = new Stable();
    }

    @Test
    public void addTest(){
        //When
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));

        //Expect
        int expect = 2;

        //Actual
        int actual = stable.total();

        Assert.assertEquals(expect, actual);
    }

    @Test
    public void removeTest(){

        Horse horse1 = new Horse("Nick", 7, true);
        Horse horse2 = new Horse("Billy", 7, true);

        //When
        stable.add(horse1);
        stable.add(horse2);
        Horse removedHorse = stable.remove(1);
        //Expect
        int expect = 1;

        //Actual
        int actual = stable.total();

        Assert.assertTrue(horse2.equals(removedHorse));

        Assert.assertEquals(expect, actual);
    }

    @Test
    public void stableIsFullTest(){
        //When
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));

        Assert.assertFalse(stable.add(new Horse("Nick", 7, true)));
    }

    @Test
    public void displayHorse(){
        //When
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));
        stable.add(new Horse("Nick", 7, true));

        //Expect
        String expect = "0. Nick\n1. Nick\n2. Nick\n3. Nick\n";

        //Actual
        String actual = stable.displayHorses();

        Assert.assertEquals(expect,actual);
    }

}