package com.zipcodewilmington.froilansfarm.Concrete;

import com.zipcodewilmington.froilansfarm.Interfaces.Produce;
import com.zipcodewilmington.froilansfarm.Interfaces.Rider;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.ArrayList;

public class TractorTest {

    Tractor tractor;
    Field field;
    CropDuster cropDuster;
    Pilot pilot;
    Farmer farmer;

    @Before
    public void setup(){
        this.tractor = new Tractor();
        this.cropDuster = new CropDuster();
        this.field = new Field();
        this.farmer = new Farmer("Nick", 13, true);
        this.pilot = new Pilot("Billy", 13, false);

        field.plantRow(this.farmer,0,  new TomatoPlant());
        field.plantRow(this.farmer,1,  new CornStalk());

        this.cropDuster.setPilot(pilot);
        this.cropDuster.setFieldToFertilize(this.field);
        field.yield();
        this.cropDuster.fertilize();
    }

    @Test
    public void harvestField() {
        //When
        tractor.setRider(this.farmer);
        tractor.setFieldToHarvest(this.field);

        int beforeHarvestCount = this.field.getProduceCount();

        ArrayList<Produce> harvestedProduce = tractor.harvest();
        Assert.assertEquals(beforeHarvestCount, harvestedProduce.size());

        //After Harvest
        int afterHarvestCount = this.field.getProduceCount();
        Assert.assertEquals(afterHarvestCount, 0);
    }


}